package de.tud.kom.p2psim.api.analyzer;

import de.tud.kom.p2psim.api.resourcedistribution.ResourceChangeListener;
import de.tud.kom.p2psim.api.resourcedistribution.ResourceModel;
import de.tudarmstadt.maki.simonstrator.api.component.core.MonitorComponent.Analyzer;
import de.tudarmstadt.maki.simonstrator.api.component.resourcedistribution.ResourceConsumer;
import de.tudarmstadt.maki.simonstrator.api.component.resourcedistribution.ResourceStateChangeListener;

/**
 * An analyzer that monitors activity of a {@link de.tud.kom.p2psim.api.resourcedistribution.ResourceModel}.
 *
 * @author Tim Feuerbach
 */
public interface ResourceAnalyzer extends Analyzer {

    /**
     * The resource model should call this during its own {@link ResourceModel#initialize()} method. The analyzer
     * can then attach a listener to the model using
     * {@link ResourceModel#addResourceChangeListener(ResourceChangeListener)},
     * and, if needed, a listener to the consumer's resource consumption state changes via
     * {@link ResourceConsumer#addStateChangeListener(ResourceStateChangeListener)}.
     */
    void initialize(ResourceConsumer consumer, ResourceModel model);
}
