package de.tud.kom.p2psim.api.util;

import java.util.Random;

/**
 * Shuffles a double array using the Durstenfeld shuffle.
 * <p/>
 * See <a href="http://stackoverflow.com/questions/1519736/random-shuffling-of-an-array">http://stackoverflow
 * .com/questions/1519736/random-shuffling-of-an-array</a>
 */
public class ArrayShuffle {
    public static void shuffle(Random random, double[] array) {
        for (int i = 0; i < array.length - 1; i++) {

            int j = random.nextInt((array.length - i)) + i;
            double tmp = array[i];
            array[i] = array[j];
            array[j] = tmp;
        }
    }

    public static void shuffle(Random random, int[] array) {
        for (int i = 0; i < array.length - 1; i++) {

            int j = random.nextInt((array.length - i)) + i;
            int tmp = array[i];
            array[i] = array[j];
            array[j] = tmp;
        }
    }

    public static <T> void shuffle(Random random, T[] array) {
        for (int i = 0; i < array.length - 1; i++) {

            int j = random.nextInt((array.length - i)) + i;
            T tmp = array[i];
            array[i] = array[j];
            array[j] = tmp;
        }
    }
}
