package de.tud.kom.p2psim.impl.loadgen.config;

import de.tud.kom.p2psim.impl.loadgen.exceptions.SiSTypeNotFoundException;
import de.tud.kom.p2psim.impl.loadgen.exceptions.UnknownComparatorType;
import de.tudarmstadt.maki.simonstrator.api.util.XMLConfigurableConstructor;

/**
 * A loader for target conditionals
 * 
 * @author Marc Schiller
 * @version 1.0, May 30, 2016
 */
public class Target extends NodeCondition {

	/**
	 * Constructor
	 * 
	 * @throws SiSTypeNotFoundException
	 *             if the wanted SiSType does not exist
	 * @throws UnknownComparatorType
	 *             if the comparator does not exist
	 */
	@XMLConfigurableConstructor({ "parameter", "comparator", "value" })
	public Target(String parameter, String comparator, String value)
			throws SiSTypeNotFoundException, UnknownComparatorType {
		super(parameter, comparator, value);
	}
}
