package de.tud.kom.p2psim.impl.topology.movement.resourceaware;

import de.tud.kom.p2psim.api.common.SimHost;
import de.tudarmstadt.maki.simonstrator.api.Host;
import de.tudarmstadt.maki.simonstrator.api.component.HostComponent;
import de.tudarmstadt.maki.simonstrator.api.component.HostComponentFactory;

/**
 * @author Tim Feuerbach
 * @see ResourceCollectionMovementMonitor
 */
public class ResourceCollectionMovementMonitorFactory implements HostComponentFactory {
    double distanceToCollect = 1.0;

    @Override
    public HostComponent createComponent(Host host) {
        assert host instanceof SimHost;
        ResourceCollectionMovementMonitor monitor = new ResourceCollectionMovementMonitor((SimHost) host);
        monitor.setDistanceToCollect(distanceToCollect);
        return monitor;
    }

    /**
     * Defines how far away a node can be to collect a resource.
     */
    public void setDistanceToCollect(double distanceToCollect) {
        this.distanceToCollect = distanceToCollect;
    }
}
